/*
 * This file was generated by qdbusxml2cpp version 0.7
 * Command line was: qdbusxml2cpp -l Oscl::Qt::DBus::BlueZ::Mesh::Provisioner1::Server -i server.h -a adaptor dbus.xml
 *
 * qdbusxml2cpp is Copyright (C) 2015 The Qt Company Ltd.
 *
 * This was an auto-generated file.
 * This file may have been hand-edited. Look for HAND-EDIT comments
 * before re-generating it.
 */

#ifndef ADAPTOR_H_1600720585
#define ADAPTOR_H_1600720585

#include <QtCore/QObject>
#include <QtDBus/QtDBus>
#include "contextapi.h"

class QByteArray;
template<class T> class QList;
template<class Key, class Value> class QMap;
class QString;
class QStringList;
class QVariant;

/*
 * Adaptor class for interface org.bluez.mesh.Provisioner1
 */
class Provisioner1Adaptor: public QDBusAbstractAdaptor {
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", "org.bluez.mesh.Provisioner1");
    Q_CLASSINFO("D-Bus Introspection", ""
"  <interface name=\"org.bluez.mesh.Provisioner1\">\n"
"    <method name=\"ScanResult\">\n"
"      <arg direction=\"in\" type=\"n\" name=\"rssi\"/>\n"
"      <arg direction=\"in\" type=\"ay\" name=\"data\"/>\n"
"      <arg direction=\"in\" type=\"a{sv}\" name=\"options\"/>\n"
"      <annotation value=\"QVariantMap\" name=\"org.qtproject.QtDBus.QtTypeName.In2\"/>\n"
"    </method>\n"
"    <method name=\"RequestProvData\">\n"
"      <arg direction=\"in\" type=\"y\" name=\"count\"/>\n"
"      <arg direction=\"out\" type=\"q\" name=\"net_index\"/>\n"
"      <arg direction=\"out\" type=\"q\" name=\"unicast\"/>\n"
"    </method>\n"
"    <method name=\"AddNodeComplete\">\n"
"      <arg direction=\"in\" type=\"ay\" name=\"uuid\"/>\n"
"      <arg direction=\"in\" type=\"q\" name=\"unicast\"/>\n"
"      <arg direction=\"in\" type=\"y\" name=\"count\"/>\n"
"    </method>\n"
"    <method name=\"AddNodeFailed\">\n"
"      <arg direction=\"in\" type=\"ay\" name=\"uuid\"/>\n"
"      <arg direction=\"in\" type=\"s\" name=\"reason\"/>\n"
"    </method>\n"
"  </interface>\n"
        "");

	private:
		/** */
		Oscl::Qt::DBus::BlueZ::
		Mesh::Provisioner1::ContextApi&	_contextApi;

		/** */
		const QDBusConnection&	_bus;

	public:
		/** */
		Provisioner1Adaptor(
			Oscl::Qt::DBus::BlueZ::
			Mesh::Provisioner1::ContextApi&	contextApi,
			const QDBusConnection&			bus,
			QObject*						parent
			);

		/** */
		virtual ~Provisioner1Adaptor();

	public slots: // METHODS
		/** */
		void	AddNodeComplete(
					const QByteArray&	uuid,
					ushort				unicast,
					uchar				count,
					const QDBusMessage&	message
					);

		/** */
		void	AddNodeFailed(
					const QByteArray&	uuid,
					const QString&		reason,
					const QDBusMessage&	message
					);

		/**
			Like input-only slots, input-and-output slots are those that
			the caller is waiting for a reply.
			Unlike input-only ones, though, this reply will contain data.
			Slots that output data may contain non-constant references and
			may return a value as well.
	
			However, the output parameters must all appear at the end
			of the argument list and may not have input arguments
			interleaved.

			***Optionally, a QDBusMessage argument may appear between
			the input and the output arguments.
		 */
		ushort	RequestProvData(
					uchar				count,
					const QDBusMessage&	message,
					ushort&				unicast
					);

		/** */
		void	ScanResult(
					short	rssi,
					const QByteArray&	data,
					const QVariantMap&	options,
					const QDBusMessage&	message
					);
};

#endif
